diff --git a/src/backend/optimizer/util/pathnode.c b/src/backend/optimizer/util/pathnode.c
new file mode 100644
index 2d5caae..79a000b
*** a/src/backend/optimizer/util/pathnode.c
--- b/src/backend/optimizer/util/pathnode.c
*************** reparameterize_path(PlannerInfo *root, P
*** 3426,3428 ****
--- 3656,4081 ----
  	}
  	return NULL;
  }
+ 
+ /*
+  * reparameterize_path_by_child
+  * 		Given a path parameterized by the parent of the given relation,
+  * 		translate the path to be parameterized by the given child relation.
+  *
+  * The function creates a new path of the same type as the given path, but
+  * parameterized by the given child relation. If it can not reparameterize the
+  * path as required, it returns NULL.
+  *
+  * The cost, number of rows, width and parallel path properties depend upon
+  * path->parent, which does not change during the translation. Hence those
+  * members are copied as they are.
+  */
+ 
+ Path *
+ reparameterize_path_by_child(PlannerInfo *root, Path *path,
+ 							  RelOptInfo *child_rel)
+ {
+ 
+ #define FLAT_COPY_PATH(newnode, node, nodetype)  \
+ 	( (newnode) = makeNode(nodetype), \
+ 	  memcpy((newnode), (node), sizeof(nodetype)) )
+ 
+ 	Path	   *new_path;
+ 	ParamPathInfo   *new_ppi;
+ 	ParamPathInfo   *old_ppi;
+ 	Relids		required_outer;
+ 
+ 	/*
+ 	 * If the path is not parameterized by parent of the given relation or it it
+ 	 * doesn't need reparameterization.
+ 	 */
+ 	if (!path->param_info ||
+ 		!bms_overlap(PATH_REQ_OUTER(path), child_rel->top_parent_relids))
+ 	return path;
+ 
+ 	/*
+ 	 * Make a copy of the given path and reparameterize or translate the
+ 	 * path specific members.
+ 	 */
+ 	switch (nodeTag(path))
+ 	{
+ 		case T_Path:
+ 			FLAT_COPY_PATH(new_path, path, Path);
+ 			break;
+ 
+ 		case T_IndexPath:
+ 			{
+ 				IndexPath *ipath;
+ 
+ 				FLAT_COPY_PATH(ipath, path, IndexPath);
+ 				ipath->indexclauses = (List *) adjust_appendrel_attrs_multilevel(root,
+ 												  (Node *) ipath->indexclauses,
+ 															 child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 				ipath->indexquals = (List *) adjust_appendrel_attrs_multilevel(root,
+ 													(Node *) ipath->indexquals,
+ 															 child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 				new_path = (Path *) ipath;
+ 			}
+ 			break;
+ 
+ 		case T_BitmapHeapPath:
+ 			{
+ 				BitmapHeapPath *bhpath;
+ 
+ 				FLAT_COPY_PATH(bhpath, path, BitmapHeapPath);
+ 				bhpath->bitmapqual = reparameterize_path_by_child(root,
+ 															bhpath->bitmapqual,
+ 																	child_rel);
+ 				new_path = (Path *) bhpath;
+ 			}
+ 			break;
+ 
+ 		case T_BitmapAndPath:
+ 			{
+ 				BitmapAndPath *bapath;
+ 				ListCell   *lc;
+ 				List	   *bitmapquals = NIL;
+ 
+ 				FLAT_COPY_PATH(bapath, path, BitmapAndPath);
+ 				foreach (lc, bapath->bitmapquals)
+ 				{
+ 					Path   *bmqpath = lfirst(lc);
+ 
+ 					bitmapquals = lappend(bitmapquals,
+ 										  reparameterize_path_by_child(root,
+ 																	   bmqpath,
+ 																   child_rel));
+ 				}
+ 				bapath->bitmapquals = bitmapquals;
+ 				new_path = (Path *) bapath;
+ 			}
+ 			break;
+ 
+ 		case T_BitmapOrPath:
+ 			{
+ 				BitmapOrPath *bopath;
+ 				ListCell   *lc;
+ 				List	   *bitmapquals = NIL;
+ 
+ 				FLAT_COPY_PATH(bopath, path, BitmapOrPath);
+ 				foreach (lc, bopath->bitmapquals)
+ 				{
+ 					Path   *bmqpath = lfirst(lc);
+ 
+ 					bitmapquals = lappend(bitmapquals,
+ 										  reparameterize_path_by_child(root,
+ 																	   bmqpath,
+ 																   child_rel));
+ 				}
+ 				bopath->bitmapquals = bitmapquals;
+ 				new_path = (Path *) bopath;
+ 			}
+ 			break;
+ 
+ 		case T_TidPath:
+ 			{
+ 				TidPath *tpath;
+ 
+ 				/*
+ 				 * TidPath contains tidquals, which do not contain any external
+ 				 * parameters per create_tidscan_path(). So don't bother to
+ 				 * translate those.
+ 				 */
+ 				FLAT_COPY_PATH(tpath, path, TidPath);
+ 				new_path = (Path *) tpath;
+ 			}
+ 			break;
+ 
+ 		case T_ForeignPath:
+ 			{
+ 				ForeignPath   *fpath;
+ 				ReparameterizeForeignPathByChild_function rfpc_func;
+ 
+ 				FLAT_COPY_PATH(fpath, path, ForeignPath);
+ 				if (fpath->fdw_outerpath)
+ 					fpath->fdw_outerpath = reparameterize_path_by_child(root,
+ 														  fpath->fdw_outerpath,
+ 																	child_rel);
+ 				rfpc_func = path->parent->fdwroutine->ReparameterizeForeignPathByChild;
+ 
+ 				/* Hand over to FDW if supported. */
+ 				if (rfpc_func)
+ 					fpath->fdw_private = rfpc_func(root, fpath->fdw_private,
+ 													child_rel);
+ 				new_path = (Path *) fpath;
+ 			}
+ 			break;
+ 
+ 		case T_CustomPath:
+ 			{
+ 				CustomPath *cpath;
+ 				ListCell   *lc;
+ 				List	   *custompaths = NIL;
+ 
+ 				FLAT_COPY_PATH(cpath, path, CustomPath);
+ 
+ 				foreach (lc, cpath->custom_paths)
+ 				{
+ 					Path   *subpath = lfirst(lc);
+ 
+ 					custompaths = lappend(custompaths,
+ 										  reparameterize_path_by_child(root,
+ 																	   subpath,
+ 																   child_rel));
+ 				}
+ 				cpath->custom_paths = custompaths;
+ 
+ 				if (cpath->methods &&
+ 					cpath->methods->ReparameterizeCustomPathByChild)
+ 					cpath->custom_private = cpath->methods->ReparameterizeCustomPathByChild(root,
+ 														 cpath->custom_private,
+ 														 child_rel);
+ 
+ 				new_path = (Path *) cpath;
+ 			}
+ 			break;
+ 
+ 		case T_NestPath:
+ 			{
+ 				JoinPath *jpath;
+ 
+ 				FLAT_COPY_PATH(jpath, path, NestPath);
+ 
+ 				jpath->outerjoinpath = reparameterize_path_by_child(root,
+ 														 jpath->outerjoinpath,
+ 														 child_rel);
+ 				jpath->innerjoinpath = reparameterize_path_by_child(root,
+ 														 jpath->innerjoinpath,
+ 														 child_rel);
+ 				jpath->joinrestrictinfo = (List *) adjust_appendrel_attrs_multilevel(root,
+ 											  (Node *) jpath->joinrestrictinfo,
+ 															 child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 				new_path = (Path *) jpath;
+ 			}
+ 			break;
+ 
+ 		case T_MergePath:
+ 			{
+ 				JoinPath *jpath;
+ 				MergePath  *mpath;
+ 
+ 				FLAT_COPY_PATH(mpath, path, MergePath);
+ 
+ 				jpath = (JoinPath *) mpath;
+ 				jpath->outerjoinpath = reparameterize_path_by_child(root,
+ 														 jpath->outerjoinpath,
+ 														 child_rel);
+ 				jpath->innerjoinpath = reparameterize_path_by_child(root,
+ 														 jpath->innerjoinpath,
+ 														 child_rel);
+ 				jpath->joinrestrictinfo = (List *) adjust_appendrel_attrs_multilevel(root,
+ 											  (Node *) jpath->joinrestrictinfo,
+ 															 child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 				mpath->path_mergeclauses = (List *) adjust_appendrel_attrs_multilevel(root,
+ 											 (Node *) mpath->path_mergeclauses,
+ 															 child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 				new_path = (Path *) mpath;
+ 			}
+ 			break;
+ 
+ 		case T_HashPath:
+ 			{
+ 				JoinPath *jpath;
+ 				HashPath   *hpath;
+ 				FLAT_COPY_PATH(hpath, path, HashPath);
+ 
+ 				jpath = (JoinPath *) hpath;
+ 				jpath->outerjoinpath = reparameterize_path_by_child(root,
+ 														 jpath->outerjoinpath,
+ 														 child_rel);
+ 				jpath->innerjoinpath = reparameterize_path_by_child(root,
+ 														 jpath->innerjoinpath,
+ 														 child_rel);
+ 				jpath->joinrestrictinfo = (List *) adjust_appendrel_attrs_multilevel(root,
+ 											  (Node *) jpath->joinrestrictinfo,
+ 															 child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 				hpath->path_hashclauses = (List *) adjust_appendrel_attrs_multilevel(root,
+ 											  (Node *) hpath->path_hashclauses,
+ 															 child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 				new_path = (Path *) hpath;
+ 			}
+ 			break;
+ 
+ 		case T_AppendPath:
+ 			{
+ 				AppendPath	*apath;
+ 				List		*subpaths = NIL;
+ 				ListCell	*lc;
+ 
+ 				FLAT_COPY_PATH(apath, path, AppendPath);
+ 				foreach (lc, apath->subpaths)
+ 					subpaths = lappend(subpaths,
+ 									   reparameterize_path_by_child(root,
+ 																	lfirst(lc),
+ 																	child_rel));
+ 				apath->subpaths = subpaths;
+ 				new_path = (Path *) apath;
+ 			}
+ 			break;
+ 
+ 		case T_MergeAppend:
+ 			{
+ 				MergeAppendPath	*mapath;
+ 				List		*subpaths = NIL;
+ 				ListCell	*lc;
+ 
+ 				FLAT_COPY_PATH(mapath, path, MergeAppendPath);
+ 				foreach (lc, mapath->subpaths)
+ 					subpaths = lappend(subpaths,
+ 									   reparameterize_path_by_child(root,
+ 																	lfirst(lc),
+ 																	child_rel));
+ 				mapath->subpaths = subpaths;
+ 				new_path = (Path *) mapath;
+ 			}
+ 			break;
+ 
+ 		case T_MaterialPath:
+ 			{
+ 				MaterialPath *mpath;
+ 
+ 				FLAT_COPY_PATH(mpath, path, MaterialPath);
+ 				mpath->subpath = reparameterize_path_by_child(root,
+ 															  mpath->subpath,
+ 															  child_rel);
+ 				new_path = (Path *) mpath;
+ 			}
+ 			break;
+ 
+ 		case T_UniquePath:
+ 			{
+ 				UniquePath *upath;
+ 
+ 				FLAT_COPY_PATH(upath, path, UniquePath);
+ 				upath->subpath = reparameterize_path_by_child(root,
+ 															  upath->subpath,
+ 															  child_rel);
+ 				upath->uniq_exprs = (List *) adjust_appendrel_attrs_multilevel(root,
+ 													(Node *) upath->uniq_exprs,
+ 															 child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 				new_path = (Path *) upath;
+ 			}
+ 			break;
+ 
+ 		case T_GatherPath:
+ 			{
+ 				GatherPath *gpath;
+ 
+ 				FLAT_COPY_PATH(gpath, path, GatherPath);
+ 				gpath->subpath = reparameterize_path_by_child(root,
+ 															  gpath->subpath,
+ 															  child_rel);
+ 				new_path = (Path *) gpath;
+ 			}
+ 			break;
+ 
+ 		case T_GatherMergePath:
+ 			{
+ 				GatherMergePath *gmpath;
+ 
+ 				FLAT_COPY_PATH(gmpath, path, GatherMergePath);
+ 				gmpath->subpath = reparameterize_path_by_child(root,
+ 															   gmpath->subpath,
+ 															   child_rel);
+ 				new_path = (Path *) gmpath;
+ 			}
+ 			break;
+ 
+ 		case T_SubqueryScanPath:
+ 			/*
+ 			 * Subqueries can't be partitioned right now, so a subquery can not
+ 			 * participate in a partition-wise join and hence can not be seen
+ 			 * here.
+ 			 */
+ 		case T_ResultPath:
+ 			/*
+ 			 * A result path can not have any parameterization, so we
+ 			 * should never see it here.
+ 			 */
+ 		default:
+ 			/* Other kinds of paths can not appear in a join tree. */
+ 			elog(ERROR, "unrecognized path node type %d", (int) nodeTag(path));
+ 
+ 			/* Keep compiler quite about unassigned new_path */
+ 			return NULL;
+ 	}
+ 
+ 	/*
+ 	 * Adjust the parameterization information, which refers to the topmost
+ 	 * parent. The topmost parent can be multiple levels away from the given
+ 	 * child, hence use multi-level expression adjustment routines.
+ 	 */
+ 	old_ppi = new_path->param_info;
+ 	required_outer = adjust_child_relids_multilevel(root,
+ 													old_ppi->ppi_req_outer,
+ 													child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 
+ 	/* If we already have a PPI for this parameterization, just return it */
+ 	new_ppi = find_param_path_info(new_path->parent, required_outer);
+ 
+ 	/*
+ 	 * If not, build a new one and link it to the list of PPIs. When called
+ 	 * during GEQO join planning, we are in a short-lived memory context.  We
+ 	 * must make sure that the new PPI and its contents attached to a baserel
+ 	 * survives the GEQO cycle, else the baserel is trashed for future GEQO
+ 	 * cycles.  On the other hand, when we are adding new PPI to a joinrel
+ 	 * during GEQO, we don't want that to clutter the main planning context.
+ 	 * Upshot is that the best solution is to explicitly allocate new PPI in
+ 	 * the same context the given RelOptInfo is in.
+ 	 */
+ 	if (!new_ppi)
+ 	{
+ 		MemoryContext oldcontext;
+ 		RelOptInfo   *rel = path->parent;
+ 
+ 		oldcontext = MemoryContextSwitchTo(GetMemoryChunkContext(rel));
+ 
+ 		new_ppi = makeNode(ParamPathInfo);
+ 		new_ppi->ppi_req_outer = bms_copy(required_outer);
+ 		new_ppi->ppi_rows = old_ppi->ppi_rows;
+ 		new_ppi->ppi_clauses = (List *) adjust_appendrel_attrs_multilevel(root,
+ 												 (Node *) old_ppi->ppi_clauses,
+ 															 child_rel->relids,
+ 												 child_rel->top_parent_relids);
+ 		rel->ppilist = lappend(rel->ppilist, new_ppi);
+ 
+ 		MemoryContextSwitchTo(oldcontext);
+ 	}
+ 	bms_free(required_outer);
+ 
+ 	new_path->param_info = new_ppi;
+ 
+ 	/*
+ 	 * Adjust the path target if the parent of the outer relation is referenced
+ 	 * in the targetlist. This can happen when only the parent of outer relation is
+ 	 * laterally referenced in this relation.
+ 	 */
+ 	if (bms_overlap(path->parent->lateral_relids, child_rel->top_parent_relids))
+ 	{
+ 		List	   *exprs;
+ 
+ 		new_path->pathtarget = copy_pathtarget(new_path->pathtarget);
+ 		exprs = new_path->pathtarget->exprs;
+ 		exprs = (List *) adjust_appendrel_attrs_multilevel(root,
+ 														   (Node *) exprs,
+ 														   child_rel->relids,
+ 											   child_rel->top_parent_relids);
+ 		new_path->pathtarget->exprs = exprs;
+ 	}
+ 
+ 	return new_path;
+ }
diff --git a/src/backend/optimizer/util/placeholder.c b/src/backend/optimizer/util/placeholder.c
new file mode 100644
index 698a387..6714288
*** a/src/backend/optimizer/util/placeholder.c
--- b/src/backend/optimizer/util/placeholder.c
***************
*** 20,25 ****
--- 20,26 ----
  #include "optimizer/pathnode.h"
  #include "optimizer/placeholder.h"
  #include "optimizer/planmain.h"
+ #include "optimizer/prep.h"
  #include "optimizer/var.h"
  #include "utils/lsyscache.h"
  
*************** add_placeholders_to_joinrel(PlannerInfo
*** 414,419 ****
--- 415,424 ----
  	Relids		relids = joinrel->relids;
  	ListCell   *lc;
  
+ 	/* This function is called only on the parent relations. */
+ 	Assert(!IS_OTHER_REL(joinrel) && !IS_OTHER_REL(outer_rel) &&
+ 		   !IS_OTHER_REL(inner_rel));
+ 
  	foreach(lc, root->placeholder_list)
  	{
  		PlaceHolderInfo *phinfo = (PlaceHolderInfo *) lfirst(lc);
*************** add_placeholders_to_joinrel(PlannerInfo
*** 459,461 ****
--- 464,518 ----
  		}
  	}
  }
+ 
+ /*
+  * add_placeholders_to_child_joinrel
+  *		Translate the PHVs in parent's targetlist and add them to the child's
+  *		targetlist. Also adjust the cost
+  */
+ void
+ add_placeholders_to_child_joinrel(PlannerInfo *root, RelOptInfo *childrel,
+ 								  RelOptInfo *parentrel)
+ {
+ 	ListCell  *lc;
+ 	AppendRelInfo **appinfos;
+ 	int		nappinfos;
+ 
+ 
+ 	Assert(IS_JOIN_REL(childrel) && IS_JOIN_REL(parentrel));
+ 
+ 	/* Ensure child relations is really what it claims to be. */
+ 	Assert(IS_OTHER_REL(childrel));
+ 
+ 	appinfos = find_appinfos_by_relids(root, childrel->relids, &nappinfos);
+ 	foreach (lc, parentrel->reltarget->exprs)
+ 	{
+ 		PlaceHolderVar *phv = lfirst(lc);
+ 
+ 		if (IsA(phv, PlaceHolderVar))
+ 		{
+ 			/*
+ 			 * In case the placeholder Var refers to any of the parent
+ 			 * relations, translate it to refer to the corresponding child.
+ 			 */
+ 			if (bms_overlap(phv->phrels, parentrel->relids) &&
+ 				childrel->reloptkind == RELOPT_OTHER_JOINREL)
+ 			{
+ 				phv = (PlaceHolderVar *) adjust_appendrel_attrs(root,
+ 															  (Node *) phv,
+ 																 nappinfos,
+ 																 appinfos);
+ 			}
+ 
+ 			childrel->reltarget->exprs = lappend(childrel->reltarget->exprs,
+ 												 phv);
+ 		}
+ 	}
+ 
+ 	/* Adjust the cost and width of child targetlist. */
+ 	childrel->reltarget->cost.startup = parentrel->reltarget->cost.startup;
+ 	childrel->reltarget->cost.per_tuple = parentrel->reltarget->cost.per_tuple;
+ 	childrel->reltarget->width = parentrel->reltarget->width;
+ 
+ 	pfree(appinfos);
+ }
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
new file mode 100644
index 9207c8d..7e846e1
*** a/src/backend/optimizer/util/plancat.c
--- b/src/backend/optimizer/util/plancat.c
***************
*** 27,32 ****
--- 27,33 ----
  #include "catalog/catalog.h"
  #include "catalog/dependency.h"
  #include "catalog/heap.h"
+ #include "catalog/pg_inherits_fn.h"
  #include "catalog/partition.h"
  #include "catalog/pg_am.h"
  #include "catalog/pg_statistic_ext.h"
*************** static List *get_relation_constraints(Pl
*** 68,73 ****
--- 69,80 ----
  static List *build_index_tlist(PlannerInfo *root, IndexOptInfo *index,
  				  Relation heapRelation);
  static List *get_relation_statistics(RelOptInfo *rel, Relation relation);
+ static List **build_baserel_partition_key_exprs(Relation relation,
+ 												Index varno);
+ static PartitionScheme find_partition_scheme(struct PlannerInfo *root,
+ 											 Relation rel);
+ static void get_relation_partition_info(PlannerInfo *root, RelOptInfo *rel,
+ 							Relation relation);
  
  /*
   * get_relation_info -
*************** get_relation_info(PlannerInfo *root, Oid
*** 420,425 ****
--- 427,436 ----
  	/* Collect info about relation's foreign keys, if relevant */
  	get_relation_foreign_keys(root, rel, relation, inhparent);
  
+ 	/* Collect info about relation's partitioning scheme, if any. */
+ 	if (inhparent)
+ 		get_relation_partition_info(root, rel, relation);
+ 
  	heap_close(relation, NoLock);
  
  	/*
*************** has_row_triggers(PlannerInfo *root, Inde
*** 1801,1803 ****
--- 1812,1975 ----
  	heap_close(relation, NoLock);
  	return result;
  }
+ 
+ /*
+  * get_relation_partition_info
+  *
+  * Retrieves partitioning information for a given relation.
+  *
+  * Partitioning scheme, partition key expressions and OIDs of partitions are
+  * added to the given RelOptInfo. A partitioned table can participate in the
+  * query as a simple relation or an inheritance parent. Only the later can have
+  * child relations, and hence partitions. From the point of view of the query
+  * optimizer only such relations are considered to be partitioned. Hence
+  * partitioning information is set only for an inheritance parent.
+  */
+ static void
+ get_relation_partition_info(PlannerInfo *root, RelOptInfo *rel,
+ 							Relation relation)
+ {
+ 	PartitionDesc	part_desc = RelationGetPartitionDesc(relation);
+ 
+ 	/* No partitioning information for an unpartitioned relation. */
+ 	if (relation->rd_rel->relkind != RELKIND_PARTITIONED_TABLE ||
+ 		!(rel->part_scheme = find_partition_scheme(root, relation)))
+ 		return;
+ 
+ 	Assert(part_desc);
+ 	rel->nparts = part_desc->nparts;
+ 	rel->boundinfo = part_desc->boundinfo;
+ 	rel->partexprs = build_baserel_partition_key_exprs(relation, rel->relid);
+ 	rel->part_oids = part_desc->oids;
+ 
+ 	Assert(rel->nparts > 0 && rel->boundinfo && rel->part_oids);
+ 	return;
+ }
+ 
+ /*
+  * find_partition_scheme
+  *
+  * The function returns a canonical partition scheme which exactly matches the
+  * partitioning properties of the given relation if one exists in the of
+  * canonical partitioning schemes maintained in PlannerInfo. If none of the
+  * existing partitioning schemes match, the function creates a canonical
+  * partition scheme and adds it to the list.
+  *
+  * For an unpartitioned table or for a multi-level partitioned table it returns
+  * NULL. See comments in the function for more details.
+  */
+ static PartitionScheme
+ find_partition_scheme(PlannerInfo *root, Relation relation)
+ {
+ 	PartitionKey	part_key = RelationGetPartitionKey(relation);
+ 	ListCell	   *lc;
+ 	int		partnatts;
+ 	PartitionScheme	part_scheme = NULL;
+ 
+ 	/* No partition scheme for an unpartitioned relation. */
+ 	if (!part_key)
+ 		return NULL;
+ 
+ 	partnatts = part_key->partnatts;
+ 
+ 	/* Search for a matching partition scheme and return if found one. */
+ 	foreach (lc, root->part_schemes)
+ 	{
+ 		part_scheme = lfirst(lc);
+ 
+ 		/* Match partitioning strategy and number of keys. */
+ 		if (part_key->strategy != part_scheme->strategy ||
+ 			partnatts != part_scheme->partnatts)
+ 			continue;
+ 
+ 		/* Match the partition key types. */
+ 		if (memcmp(part_key->partopfamily, part_scheme->partopfamily,
+ 				   sizeof(Oid) * partnatts) != 0 ||
+ 			memcmp(part_key->partopcintype, part_scheme->partopcintype,
+ 				   sizeof(Oid) * partnatts) != 0 ||
+ 			memcmp(part_key->parttypcoll, part_scheme->parttypcoll,
+ 				   sizeof(Oid) * partnatts) != 0)
+ 			continue;
+ 
+ 		/* Found matching partition scheme. */
+ 		return part_scheme;
+ 	}
+ 
+ 	/* Did not find matching partition scheme. Create one. */
+ 	part_scheme = (PartitionScheme) palloc0(sizeof(PartitionSchemeData));
+ 
+ 	part_scheme->strategy = part_key->strategy;
+ 	/* Store partition key information. */
+ 	part_scheme->partnatts = part_key->partnatts;
+ 	part_scheme->partopfamily = part_key->partopfamily;
+ 	part_scheme->partopcintype = part_key->partopcintype;
+ 	part_scheme->parttypcoll = part_key->parttypcoll;
+ 	part_scheme->partsupfunc = part_key->partsupfunc;
+ 
+ 	/* Add the partitioning scheme to PlannerInfo. */
+ 	root->part_schemes = lappend(root->part_schemes, part_scheme);
+ 
+ 	return part_scheme;
+ }
+ 
+ /*
+  * build_baserel_partition_key_exprs
+  *
+  * Collect partition key expressions for a given base relation. The function
+  * converts any single column partition keys into corresponding Var nodes. It
+  * restamps Var nodes in partition key expressions by given varno. The
+  * partition key expressions are returned as an array of single element lists
+  * to be stored in RelOptInfo of the base relation.
+  */
+ static List **
+ build_baserel_partition_key_exprs(Relation relation, Index varno)
+ {
+ 	PartitionKey	part_key = RelationGetPartitionKey(relation);
+ 	int		num_pkexprs;
+ 	int		cnt_pke;
+ 	List	  **partexprs;
+ 	ListCell   *lc;
+ 
+ 	if (!part_key || part_key->partnatts <= 0)
+ 		return NULL;
+ 
+ 	num_pkexprs = part_key->partnatts;
+ 	partexprs = (List **) palloc(sizeof(List *) * num_pkexprs);
+ 	lc = list_head(part_key->partexprs);
+ 
+ 	for (cnt_pke = 0; cnt_pke < num_pkexprs; cnt_pke++)
+ 	{
+ 		AttrNumber attno = part_key->partattrs[cnt_pke];
+ 		Expr	  *pkexpr;
+ 
+ 		if (attno != InvalidAttrNumber)
+ 		{
+ 			/* Single column partition key is stored as a Var node. */
+ 			Form_pg_attribute att_tup;
+ 
+ 			if (attno < 0)
+ 				att_tup = SystemAttributeDefinition(attno,
+ 												 relation->rd_rel->relhasoids);
+ 			else
+ 				att_tup = relation->rd_att->attrs[attno - 1];
+ 
+ 			pkexpr = (Expr *) makeVar(varno, attno, att_tup->atttypid,
+ 									  att_tup->atttypmod,
+ 									  att_tup->attcollation, 0);
+ 		}
+ 		else
+ 		{
+ 			if (lc == NULL)
+ 				elog(ERROR, "wrong number of partition key expressions");
+ 
+ 			/* Re-stamp the expression with given varno. */
+ 			pkexpr = (Expr *) copyObject(lfirst(lc));
+ 			ChangeVarNodes((Node *) pkexpr, 1, varno, 0);
+ 			lc = lnext(lc);
+ 		}
+ 
+ 		partexprs[cnt_pke] = list_make1(pkexpr);
+ 	}
+ 
+ 	return partexprs;
+ }
